# CEGUI::ScriptModule Class Reference

Abstract interface required for all scripting support modules to be used with the CEGUI system. More...

Collaboration diagram for CEGUI::ScriptModule:

[legend]
List of all members.

## Public Member Functions

| ScriptModule (void)
| Constructor for ScriptModule base class.
virtual | ~ScriptModule (void)
| Destructor for ScriptModule base class.
virtual void | executeScriptFile (const String &filename, const String &resourceGroup="")=0
| Execute a script file.
virtual int | executeScriptGlobal (const String &function_name)=0
| Execute a scripted global function. The function should not take any parameters and should return an integer.
virtual bool | executeScriptedEventHandler (const String &handler_name, const EventArgs &e)=0
| Execute a scripted global 'event handler' function. The function should take some kind of EventArgs like parameter that the concrete implementation of this function can create from the passed EventArgs based object. The function should not return anything.
virtual void | executeString (const String &str)=0
| Execute script code contained in the given CEGUI::String object.
virtual void | createBindings (void)
| Method called during system initialisation, prior to running any scripts via the ScriptModule, to enable the ScriptModule to perform any operations required to complete initialisation or binding of the script language to the gui system objects.
virtual void | destroyBindings (void)
| Method called during system destruction, after all scripts have been run via the ScriptModule, to enable the ScriptModule to perform any operations required to cleanup bindings of the script language to the gui system objects, as set-up in the earlier createBindings call.
const String & | getIdentifierString () const
| Return identification string for the ScriptModule. If the internal id string has not been set by the ScriptModule creator, a generic string of "Unknown scripting module" will be returned.

## Protected Attributes

String | d_identifierString
| String that holds some id information about the module.

## Detailed Description

Abstract interface required for all scripting support modules to be used with the CEGUI system.

## Member Function Documentation

virtual void CEGUI::ScriptModule::createBindings | ( | void |  | ) | `[inline, virtual]`

Method called during system initialisation, prior to running any scripts via the ScriptModule, to enable the ScriptModule to perform any operations required to complete initialisation or binding of the script language to the gui system objects.

Returns:
  Nothing.

virtual void CEGUI::ScriptModule::destroyBindings | ( | void |  | ) | `[inline, virtual]`

Method called during system destruction, after all scripts have been run via the ScriptModule, to enable the ScriptModule to perform any operations required to cleanup bindings of the script language to the gui system objects, as set-up in the earlier createBindings call.

Returns:
  Nothing.

virtual bool CEGUI::ScriptModule::executeScriptedEventHandler | ( | const String & | handler_name,
|  | const EventArgs & | e
| ) | `[pure virtual]`

Execute a scripted global 'event handler' function. The function should take some kind of EventArgs like parameter that the concrete implementation of this function can create from the passed EventArgs based object. The function should not return anything.

Parameters:

  | handler_name | String object holding the name of the scripted handler function.
  | e | EventArgs based object that should be passed, by any appropriate means, to the scripted function.

Returns:
  - true if the event was handled.
  - false if the event was not handled.

virtual void CEGUI::ScriptModule::executeScriptFile | ( | const String & | filename,
|  | const String & | resourceGroup = `""`
| ) | `[pure virtual]`

Execute a script file.

Parameters:

  | filename | String object holding the filename of the script file that is to be executed
  | resourceGroup | Resource group idendifier to be passed to the ResourceProvider when loading the script file.

virtual int CEGUI::ScriptModule::executeScriptGlobal | ( | const String & | function_name | ) | `[pure virtual]`

Execute a scripted global function. The function should not take any parameters and should return an integer.

Parameters:

  | function_name | String object holding the name of the function, in the global script environment, that is to be executed.

Returns:
  The integer value returned from the script function.

virtual void CEGUI::ScriptModule::executeString | ( | const String & | str | ) | `[pure virtual]`

Execute script code contained in the given CEGUI::String object.

Parameters:

  | str | String object holding the valid script code that should be executed.

Returns:
  Nothing.

const String & CEGUI::ScriptModule::getIdentifierString | ( |  | ) | const

Return identification string for the ScriptModule. If the internal id string has not been set by the ScriptModule creator, a generic string of "Unknown scripting module" will be returned.

Returns:
  String object holding a string that identifies the ScriptModule in use.